/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-30 17:43
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 2e5 + 5;
ll M, N;

void solve(){
    // Code goes here ...
    cin >> M >> N;
    
    vector<vector<int>> grid(M + 2, vector<int>(N + 2, 0));
    vector<int> rc(M + 2, 0), cc(N + 2, 0), cLs(N + 2, 0);

    string row;
    int curups;

    R(i, M){
        cin >> row;
        curups = 0;
        R(j, N){
            if(row[j] == '.')
                grid[i][j] = '.';
            else{
                rc[i]++, cc[j]++;
                if(row[j] == 'U'){
                    curups ++;
                    grid[i][j]   = curups % 2 ? 'W' : 'B';
                    grid[i+1][j] = curups % 2 ? 'B' : 'W';
                    /* grid[i][j] = grid[i+1][j] = cnt++; */
                }
                if(row[j] == 'L'){
                    cLs[j]++;
                    grid[i][j]     = cLs[j] % 2 ? 'W' : 'B';
                    grid[i][j + 1] = cLs[j] % 2 ? 'B' : 'W';
                    /* grid[i][j] = grid[i][j+1] = cnt++; */
                }
            }
        }
    }

    R(i, M)
        if(rc[i] % 2){
            cout << -1 << endl;
            return;
        }
    R(i, N)
        if(cc[i] % 2){
            cout << -1 << endl;
            return;
        }

    R(i, M){
        R(j, N){
            cout << (char) grid[i][j];
        }
        cout << endl;
    }

}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
